#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

typedef long long ll;
typedef pair<int, int> edge;

string get_invalid_answer_cause(ll cause) {
    switch (cause) {
        case -1:
            return "declared answer not equal to answer in the transmitted graph";
        case -2:
            return "it contains edge that was not in original graph";
        case -3:
            return "it contains a multiple edge";
        default:
            return toString(cause);
    }
}

ll readAnswer(int n, int m, set<edge> &edges, InStream &inStream) {
    ll n_ll = n;
    ll max_ans = n_ll * n_ll * n_ll;
    ll ansValue = inStream.readLong(0, max_ans, "ans");
    ll realAns = 0;
    inStream.readEoln();

    vector<vector<int>> degs(2, vector<int>(n + 1, 0));
    set<edge> used_edges;
    // out, in

    for (int i = 0; i < m; ++i) {
        int u = inStream.readInt(1, n, "x_i");
        int v = inStream.readInt(1, n, "y_i");
        // u -> v
        edge cur_e(min(u, v), max(u, v));
        if (edges.find(cur_e) == edges.end()) {
            return -2;
        }
        if (used_edges.find(cur_e) != used_edges.end()) {
            return -3;
        }
        used_edges.insert(cur_e);
        degs[0][u]++;
        degs[1][v]++;
    }

    for (int i = 1; i <= n; ++i) {
        realAns += degs[0][i] * degs[1][i];
    }

    if (realAns != ansValue) {
        return -1;
    }
    return ansValue;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    int m = inf.readInt();

    set<edge> edges;
    for (int i = 0; i < m; ++i) {
        int u = inf.readInt(1, n);
        int v = inf.readInt(1, n);
        edges.emplace(min(u, v), max(u, v));
    }

    ll juryAnswer = readAnswer(n, m, edges, ans);
    ll pAnswer = readAnswer(n, m, edges, ouf);
    if (juryAnswer < 0) {
        quitf(_fail, "jury answer is invalid %lld", juryAnswer);
    }
    if (pAnswer < 0) {
        string cause = get_invalid_answer_cause(pAnswer);
        quitf(_wa, "participant's answer is invalid, %s", cause.c_str());
    }
    if (juryAnswer < pAnswer) {
        quitf(_fail, "participant's answer is better then jury");
    }
    if (juryAnswer > pAnswer) {
        quitf(_wa, "participant's answer %lld is different from actual %lld", pAnswer,
              juryAnswer);
    }
    quitf(_ok, "%lld", juryAnswer);
}
