using namespace std;

#include <iostream>
#include <unordered_set>
#include "testlib.h"

const int max_deg = 2;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_n = opt<int>("n");
    int max_m = opt<int>("m");
    int max_m_w = opt<int>("mw");


    int n = 2 + rnd.next(max_n - 1);
    max_m = min(max_m, n > 2 ? n : 1);
    int m = rnd.wnext(max_m, max_m_w) + 1;
    printf("%d %d\n", n, m);

    set <pair<int, int>> already_was;
    vector <pair<int, int>> deg_counter;
    for (int i = 1; i <= n; ++i) {
        deg_counter.emplace_back(i, 0);
    }


    for (int i = 0; i < m; ++i) {
        int u = 0, v = 0;
        do {
            int u_n = rnd.next(0, (int) deg_counter.size() - 1);
            int v_n = rnd.next(0, (int) deg_counter.size() - 1);

            if (v_n == u_n) { continue; }
            if (already_was.find(make_pair(deg_counter[u_n].first, deg_counter[v_n].first)) == already_was.end()) {
                u = deg_counter[u_n].first;
                v = deg_counter[v_n].first;
                ++deg_counter[u_n].second;
                if (deg_counter[u_n].second == max_deg) {
                    deg_counter[u_n] = deg_counter.back();
                    if (v_n == deg_counter.size() - 1) {
                        v_n = u_n;
                    }
                    deg_counter.pop_back();
                }
                ++deg_counter[v_n].second;
                if (deg_counter[v_n].second == max_deg) {
                    deg_counter[v_n] = deg_counter.back();
                    deg_counter.pop_back();
                }
            }
        } while (u == 0);

        printf("%d %d\n", u, v);
        already_was.emplace(u, v);
        already_was.emplace(v, u);
    }


    return 0;
}
