using namespace std;

#include <iostream>
#include <unordered_set>
#include "testlib.h"

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_n = opt<int>("n");
    int max_m_w = opt<int>("nw");
    int qw = opt<int>("qw");


    int n = 2 + rnd.wnext(max_n - 1, max_m_w);
    printf("%d %d\n", n, n - 1);

    vector<int> p(n + 1), perm(n + 1);
    perm[1] = 1;

    for (int i = 2; i <= n; ++i) {
        p[i] = 1 + rnd.wnext(i - 1, qw);
        perm[i] = i;
    }

    vector <pair<int, int>> edges;
    for (int i = 2; i <= n; ++i) {
        if (rnd.next(0, 1)) {
            edges.emplace_back(i, p[i]);
        } else {
            edges.emplace_back(p[i], i);
        }
    }
    shuffle(edges.begin(), edges.end());
    shuffle(perm.begin() + 1, perm.end());
    for(int i = 0; i < n - 1; ++i) {
        cout << perm[edges[i].first] << " " << perm[edges[i].second] << "\n";
    }

    return 0;
}
