using namespace std;

#include <bits/stdc++.h>

#define ll long long
#define ull unsigned ll
#define ld long double
#define pb push_back
#define mp make_pair
#define fori(i, n) for (int i = 0; i < n; ++i)
#define fori1(i, n) for (int i = 1; i <= n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(x) (x)*(x)
#define db_(x) cout << x << ' ';
#define db(x) cout << x << '\n';

struct edge {
    edge() = default;

    edge(int u, int v, bool fake) : u(u), v(v), fake(fake) {
    }

    int u;
    int v;
    bool fake;

    void swap() {
        int t;
        t = v;
        v = u;
        u = t;
    };

    int edge_to(int cur_v) const {
        return cur_v == v ? u : (cur_v == u) ? v : 0;
    }
};

void solver() {
    int n, m;
    cin >> n >> m;
    vector <edge> edges(m + 1);
    vector <vector<int>> nodes(n + 1);
    fori1(i, m) {
        cin >> edges[i].u >> edges[i].v;
        nodes[edges[i].u].pb(i);
        nodes[edges[i].v].pb(i);
    }
    int prev_odd = 0;
    fori1(i, n) {
        if (nodes[i].size() % 2 == 0) {
            continue;
        }

        if (prev_odd == 0) {
            prev_odd = i;
            continue;
        }
        nodes[i].pb(edges.size());
        nodes[prev_odd].pb(edges.size());
        edges.emplace_back(prev_odd, i, true);
        prev_odd = 0;
    }

    // euler path
    stack <pair<int, int>> ep_st; // node, e_n
    vector<bool> visited_nodes(n + 1);
    vector<bool> visited_edges(edges.size() + 1);
    vector <pair<int, int>> ep_order;
    fori1(start_from, n) {
        if (visited_nodes[start_from]) { continue; }
        ep_st.emplace(start_from, 0);
        while (!ep_st.empty()) {
            auto ep_st_top = ep_st.top();
            int w = ep_st_top.first;

            bool found = false;
            while (!nodes[w].empty()) {
                int e_n = nodes[w].back();
                nodes[w].pop_back();
                if (visited_edges[e_n]) { continue; }
                edge &e = edges[e_n];
                visited_edges[e_n] = true;
                ep_st.emplace(e.edge_to(w), e_n);
                found = true;
                break;
            }
            if (!found) {
                ep_st.pop();
                visited_nodes[w] = true;
                if (ep_st_top.second != 0) ep_order.emplace_back(ep_st_top.second, w);
            }
        }
    }

    vector <vector<ll>> res_degs(2, vector<ll>(n + 1));
    for (auto ep_eg : ep_order) {
        edge e = edges[ep_eg.first];
        int u = ep_eg.second;
        int v = e.edge_to(u);
        if (e.fake) {
            continue;
        }
        res_degs[0][u]++;
        res_degs[1][v]++;
    }
    ll ans = 0;
    fori1(i, n) {
        ans += res_degs[0][i] * res_degs[1][i];
    }
    cout << ans << "\n";
    for (auto ep_eg : ep_order) {
        edge e = edges[ep_eg.first];
        int u = ep_eg.second;
        int v = e.edge_to(u);
        if (e.fake) {
            continue;
        }
        cout << u << " " << v << "\n";
    }
}

int main() {
#ifdef _DEBUG_INPUT_FILE
    freopen("test.in", "r", stdin);
#endif
    //    ios_base::sync_with_stdio(false);
    //    cin.tie(nullptr);
    //    cout.tie(nullptr);


    int q = 1;
//    cin >> q;
    fori(i, q) {
        solver();
    }
}