#include "testlib.h"

using namespace std;

pair<int, string> check(string const &origin, InStream &in) {
    string res = in.readToken("[0-9]+", "answer");
    if (res == "0")
        return {1, res};
    in.ensuref(res[0] != '0', "leading zero present in non-zero answer");

    int it = 0, total = 0;
    for (int i = 0; i < res.size(); i++) {
        total = (total + res[i] - '0') % 3;
        while (it < origin.size() && origin[it] != res[i]) it++;
        in.ensuref(it < origin.size(),
                   "the answer is not a substring of the input: answer[%d] = %c not found",
                   i + 1, res[i]);
        it++;
    }

    in.ensuref(total == 0, "the answer is not a multiple of 3");
    return {res.size(), res};
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    inf.readInt();
    string s = inf.readToken();
    auto ja = check(s, ans), pa = check(s, ouf);
    if (ja < pa)
        quitf(_fail, "participant has better answer (%d, %s...) against (%d, %s...)",
              pa.first, pa.second.substr(0, 6).c_str(), ja.first, ja.second.substr(0, 6).c_str());
    if (pa < ja)
        quitf(_wa, "jury has better answer (%d, %s...) against (%d, %s...)",
              ja.first, ja.second.substr(0, 6).c_str(), pa.first, pa.second.substr(0, 6).c_str());

    quitf(_ok, "all checks passed, answer is %s...", ja.second.substr(0, 20).c_str());

}