using namespace std;

#include <iostream>
#include "testlib.h"

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_k = opt<int>("k");
    int k_w = opt<int>("k_w");
    int n_f_w = opt<int>("n_f_w");
    bool do_sort = opt<bool>("sort");
    int two_type_mode = opt<int>("sp");
    bool zero_mode = opt<bool>("zm");
    bool with_zero = zero_mode || opt<bool>("z");
    int zero_interval = 0;
    int sp_other_type = 0;


    int k = rnd.wnext(max_k, k_w) + 1;

    printf("%d\n", k);

    zero_mode = zero_mode && k > 4;
    if (zero_mode) {
        // at least one non-zero at the end
        zero_interval = 1 + rnd.wnext(k - 2, -1);
        k -= zero_interval + 1;
    }
    vector<int> numbers(k);

    if (two_type_mode == 0) {
        numbers[0] = 1 + rnd.wnext(9, n_f_w);
        for (int i = 1; i < k; ++i) {
            numbers[i] = rnd.next((with_zero && !do_sort) ? 0 : 1, 9);
        }
    } else {
        sp_other_type = rnd.next(1, 2); // some numbers will be multiples 3,
        int need_not_mpls = 0; //  some numbers will have remains "sp_other_type"
        if (two_type_mode == 1) {
            need_not_mpls = 1 + 2 * rnd.next(0, (k - 1) / 2); // must be odd
        } else if (two_type_mode == 2) {
            need_not_mpls = 2 * rnd.next(0, k / 2); // must be even
        } else if (two_type_mode == 3) {
            need_not_mpls = 3 * rnd.next(0, (k - 1) / 3); // must be even multiples 3
        }
        int need_mpls = k - need_not_mpls;
        for (int i = 0; i < k; ++i) {
            bool curType = rnd.next(need_mpls + need_not_mpls) >= need_mpls;
            if (!curType) { // % 3 = 0
                --need_mpls;
                numbers[i] = rnd.next(((!do_sort && with_zero && i > 0) ? 0 : 1), 3) * 3;
            } else { // % 3 != 0
                --need_not_mpls;
                numbers[i] = rnd.next(0, 2) * 3 + sp_other_type;
            }
        }
    }

    if (do_sort) {
        sort(numbers.begin(), numbers.end());
    }
    if (zero_mode) {
        if (sp_other_type == 0) {
            sp_other_type = rnd.next(1, 2);
        }
        int first_number = 3 * rnd.next(0, 2) + ((sp_other_type * 2) % 3);
        printf("%d", first_number);
        for (int i = 0; i < zero_interval; ++i) {
            printf("0");
        }
        for (int i = 0; i < k; ++i) {
            printf("%d", numbers[i]);
        }
    } else {
        for (int i = 0; i < k; ++i) {
            printf("%d", numbers[i]);
        }
    }
    printf("\n");

    return 0;
}
