using namespace std;

#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

typedef long long ll;

const ll max_k = 500000;

int main(int argc, char *argv[]) {
    set <string> no_zeros_group({"4", "5", "6"});
    registerValidation(argc, argv);

    bool with_zeros = no_zeros_group.find(validator.group()) == no_zeros_group.end();
    bool with_order = validator.group() == "5";
    int k = inf.readInt(1, max_k, "k");
    ensuref(validator.group() != "1" || k <= 3, "g1: k = %d > 3", k);
    ensuref(validator.group() != "2" || k <= 6, "g2: k = %d > 6", k);
    ensuref(validator.group() != "3" || k <= 18, "g3: k = %d > 18", k);
    ensuref(validator.group() != "4" || k <= 350, "g4: k = %d > 350", k);
    inf.readEoln();
    char fist_number = inf.readChar();
    ensuref('1' <= fist_number && fist_number <= '9', "n_0 = %c", fist_number);
    char prev_char = fist_number;
    for (int i = 1; i < k; ++i) {
        char cur_number = inf.readChar();
        ensuref((with_zeros ? '0' : '1') <= cur_number && cur_number <= '9', "n_%d = %c", i, cur_number);
        ensuref(!with_order || prev_char <= cur_number, "g5: no sort, n_%d > n_%d", i - 1, i);
        prev_char = cur_number;
    }
    inf.readEoln();
    inf.readEof();

    return 0;
}
