#include "testlib.h"

using namespace std;

typedef pair<int, int> pii;
int const maxw = 20'000;

int check(int s, vector<pii> const &sales, InStream &in) {
    int n = sales.size();
    int t = in.readInt(-maxw, maxw, "ans"), k = in.readInt(0, n, "k");

    set<int> used;
    for (int i = 0; i < k; i++) {
        int no = in.readInt(1, n, format("no_%d", i + 1)) - 1;
        in.ensuref(used.count(no) == 0, "sale number %d already used", no + 1);
        used.insert(no);

        in.ensuref(s >= sales[no].first,
                   "sale number %d can not be used on step %d: %d < %d",
                   no + 1, i + 1, s, sales[no].first);
        s += sales[no].second;
    }

    in.ensuref(s == t, "expected to get ans = %d, got %d", t, s);
    return t;
}

int main(int argc, char *argv[]) {

    registerTestlibCmd(argc, argv);

    int n = inf.readInt(), s = inf.readInt();
    vector<pii> sales(n);
    for (int i = 0; i < n; i++) {
        sales[i].first = inf.readInt();
        sales[i].second = inf.readInt();
    }

    int ja = check(s, sales, ans), pa = check(s, sales, ouf);
    if (ja < pa)
        quitf(_wa, "jury has better answer %d < %d", ja, pa);
    if (ja > pa)
        quitf(_fail, "participant has better answer %d < %d", pa, ja);

    quitf(_ok, "answer %d, all checks passed", ja);

}