#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);
    int group = validator.group() == "" ? -1 : validator.group()[0] - '0';
    int const w = 10'000;

    int n = inf.readInt(1, 1000, "n");
    inf.readSpace();
    inf.readInt(0, w, "s");
    inf.readEoln();

    vector<int> a(n), b(n);
    int total = 0, neg = 0, any_neg = 0;
    for (int i = 0; i < n; i++) {
        a[i] = inf.readInt(0, 2 * w, format("a_%d", i + 1));
        inf.readSpace();
        b[i] = inf.readInt(-w, w, format("b_%d", i + 1));
        inf.readEoln();

        total += abs(b[i]);
        if (b[i] < 0) any_neg = b[i], neg++;
    }
    ensuref(total <= 2 * w, "total sum of abs(bi) is %d, exceeds %d", total, 2 * w);

    inf.readEof();

    switch (group) {
        case 1:
            ensuref(n <= 8, "group 1: n is %d, exceeds 8", n);
            break;
        case 2:
            ensuref(n <= 20, "group 2: n is %d, exceeds 20", n);
            ensuref(neg == n, "group 2: %d non-negative sales present", n - neg);
            break;
        case 3:
            ensuref(neg == 1, "group 3: %d negative sales present, 1 expected", neg);
            break;
        case 4:
            for (int i = 0; i < n; i++)
                ensuref(a[i] == 0, "group 4: non-zero a[%d] = %d present", i + 1, a[i]);
            break;
        case 5:
            for (int i = 0; i < n; i++)
                ensuref(b[i] >= 0 || b[i] == any_neg,
                        "group 5: negative b[%d] = %d is not equal to last %d", i + 1, b[i], any_neg);
            break;
        case 6:
            ensuref(neg <= 20, "group 6: %d negative sales present, exceeds 20", neg);
            break;
    }

}