#include <bits//stdc++.h>

#define ll long long
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define ld long double


const int mod = 1e9 + 9;


using namespace std;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


ll rnd(ll l, ll r) {
    uniform_int_distribution<ll> range(l, r);
    return range(rng);
}


template <class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (T &x : arr) {
        in >> x;
    }
    return in;
}


const int MAX_S = 2e4 + 1;


struct stonk {
    int delta, bound, index;
};


void solve() {
    int n, s;
    cin >> n >> s;
    vector<stonk> positive, negative;
    for (int i = 1; i <= n; i++) {
        int bound, delta;
        cin >> bound >> delta;
        if (delta == 0) {
            continue;
        }
        if (delta < 0) {
            negative.pb({delta, bound, i});
        } else {
            positive.pb({delta, bound, i});
        }
    }
    sort(all(positive), [&](stonk a, stonk b) {
        return a.bound < b.bound;
    });
    vector<vector<int>> can(positive.size() + 1, vector<int>(MAX_S, -1)); // -1 - cant, 0 - didn't take, 1 - took
    can[0][0] = 0;
    for (int i = 1; i <= positive.size(); i++) {
        int d = positive[i - 1].delta, b = positive[i - 1].bound;
        for (int w = 0; w < MAX_S; w++) {
            if (can[i - 1][w] != -1) {
                can[i][w] = 0;
                continue;
            }
            if (w >= d && s + w - d >= b && can[i - 1][w - d] != -1) {
                can[i][w] = 1;
            }
        }
    }
    sort(all(negative), [&](stonk a, stonk b) {
        return a.bound + a.delta > b.bound + b.delta;
    });
    int inf = 1e9;
    vector<vector<int>> dp(negative.size() + 1, vector<int>(MAX_S, inf)),
                        pr(negative.size() + 1, vector<int>(MAX_S, -1));
    dp[0][0] = 0;
    for (int i = 1; i <= negative.size(); i++) {
        int b = negative[i - 1].bound, d = -negative[i - 1].delta;
        for (int w = 0; w < MAX_S; w++) {
            dp[i][w] = dp[i - 1][w];
            pr[i][w] = 0; // didn't take
            if (w >= d && dp[i][w] > max(dp[i - 1][w - d], b + w)) {
                dp[i][w] = max(dp[i - 1][w - d], b + w - d);
                pr[i][w] = 1;
            }
        }
    }
    vector<int> canUp;
    for (int i = 0; i < MAX_S; i++) {
        if (can.back()[i] != -1) {
            canUp.pb(i);
        }
    }
    int bestAnswer = inf, bestDown = -1, bestUp = -1;
    for (int downW = 0; downW < MAX_S; downW++) {
        if (dp.back()[downW] == inf) {
            continue;
        }
        auto ptr = lower_bound(all(canUp), dp.back()[downW] - s);
        if (ptr != canUp.end() && s + *ptr - downW < bestAnswer) {
            bestAnswer = *ptr + s - downW;
            bestDown = downW;
            bestUp = *ptr;
        }
    }
    vector<int> o1, o2;
    int i = positive.size();
    while (i > 0) {
        if (can[i][bestUp] == 1) {
            o1.pb(positive[i - 1].index);
            bestUp -= positive[i - 1].delta;
        }
        i--;
    }
    i = negative.size();
    while (i > 0) {
        if (pr[i][bestDown] == 1) {
            o2.pb(negative[i - 1].index);
            bestDown += negative[i - 1].delta;
        }
        i--;
    }
    cout << bestAnswer << " " << o1.size() + o2.size() << "\n";
    while (!o1.empty()) {
        cout << o1.back() << " ";
        o1.pop_back();
    }
    while (!o2.empty()) {
        cout << o2.back() << " ";
        o2.pop_back();
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}